"""
Defines the behavior of the application.
"""

import ctypes
import widget
import tkinter.messagebox as tkmsg

class Application(object):
    def __init__(self):
        # Create dialog
        self.dlg = widget.Usbif4cwPortIoDlg()

        # Associate events
        self.dlg.btn_p00["command"] = self.on_btn_p00
        self.dlg.btn_p01["command"] = self.on_btn_p01
        self.dlg.btn_p02["command"] = self.on_btn_p02
        self.dlg.btn_p03["command"] = self.on_btn_p03
        self.dlg.btn_p04["command"] = self.on_btn_p04
        self.dlg.btn_p05["command"] = self.on_btn_p05
        self.dlg.btn_p06["command"] = self.on_btn_p06
        self.dlg.btn_p07["command"] = self.on_btn_p07
        self.dlg.btn_p10["command"] = self.on_btn_p10
        self.dlg.btn_p11["command"] = self.on_btn_p11
        self.dlg.btn_p12["command"] = self.on_btn_p12
        self.dlg.btn_p13["command"] = self.on_btn_p13
        self.dlg.protocol("WM_DELETE_WINDOW", self.on_destroy)

        # initialize USBIF4CW.dll
        self.lib = ctypes.windll.LoadLibrary("./usbif4cw.dll");
        if (self.lib.usbif4cwOpen(0) < 0):
            tkmsg.showerror('ERROR', 'USBIF4CW not found. Please check the connection.')
            self.dlg.destroy()
        self.port0_data = 0xFF
        self.port1_data = 0x0F

    def on_btn_p00(self):
        if self.dlg.btn_p00["relief"] == "raised":
            self.dlg.btn_p00["relief"] = "sunken"
            self.port0_data &= 0xFE
        else:
            self.dlg.btn_p00["relief"] = "raised"
            self.port0_data |= 0x01;
        self.lib.usbif4cwWriteData(0, 0, self.port0_data)

    def on_btn_p01(self):
        if self.dlg.btn_p01["relief"] == "raised":
            self.dlg.btn_p01["relief"] = "sunken"
            self.port0_data &= 0xFD
        else:
            self.dlg.btn_p01["relief"] = "raised"
            self.port0_data |= 0x02;
        self.lib.usbif4cwWriteData(0, 0, self.port0_data)

    def on_btn_p02(self):
        if self.dlg.btn_p02["relief"] == "raised":
            self.dlg.btn_p02["relief"] = "sunken"
            self.port0_data &= 0xFB
        else:
            self.dlg.btn_p02["relief"] = "raised"
            self.port0_data |= 0x04;
        self.lib.usbif4cwWriteData(0, 0, self.port0_data)

    def on_btn_p03(self):
        if self.dlg.btn_p03["relief"] == "raised":
            self.dlg.btn_p03["relief"] = "sunken"
            self.port0_data &= 0xF7
        else:
            self.dlg.btn_p03["relief"] = "raised"
            self.port0_data |= 0x08;
        self.lib.usbif4cwWriteData(0, 0, self.port0_data)

    def on_btn_p04(self):
        if self.dlg.btn_p04["relief"] == "raised":
            self.dlg.btn_p04["relief"] = "sunken"
            self.port0_data &= 0xEF
        else:
            self.dlg.btn_p04["relief"] = "raised"
            self.port0_data |= 0x10;
        self.lib.usbif4cwWriteData(0, 0, self.port0_data)

    def on_btn_p05(self):
        if self.dlg.btn_p05["relief"] == "raised":
            self.dlg.btn_p05["relief"] = "sunken"
            self.port0_data &= 0xDF
        else:
            self.dlg.btn_p05["relief"] = "raised"
            self.port0_data |= 0x20;
        self.lib.usbif4cwWriteData(0, 0, self.port0_data)

    def on_btn_p06(self):
        if self.dlg.btn_p06["relief"] == "raised":
            self.dlg.btn_p06["relief"] = "sunken"
            self.port0_data &= 0xBF
        else:
            self.dlg.btn_p06["relief"] = "raised"
            self.port0_data |= 0x40;
        self.lib.usbif4cwWriteData(0, 0, self.port0_data)

    def on_btn_p07(self):
        if self.dlg.btn_p07["relief"] == "raised":
            self.dlg.btn_p07["relief"] = "sunken"
            self.port0_data &= 0x7F
        else:
            self.dlg.btn_p07["relief"] = "raised"
            self.port0_data |= 0x80;
        self.lib.usbif4cwWriteData(0, 0, self.port0_data)

    def on_btn_p10(self):
        if self.dlg.btn_p10["relief"] == "raised":
            self.dlg.btn_p10["relief"] = "sunken"
            self.port1_data &= 0x0E
        else:
            self.dlg.btn_p10["relief"] = "raised"
            self.port1_data |= 0x01;
        self.lib.usbif4cwWriteData(0, 1, self.port1_data)

    def on_btn_p11(self):
        if self.dlg.btn_p11["relief"] == "raised":
            self.dlg.btn_p11["relief"] = "sunken"
            self.port1_data &= 0x0D
        else:
            self.dlg.btn_p11["relief"] = "raised"
            self.port1_data |= 0x02;
        self.lib.usbif4cwWriteData(0, 1, self.port1_data)

    def on_btn_p12(self):
        if self.dlg.btn_p12["relief"] == "raised":
            self.dlg.btn_p12["relief"] = "sunken"
            self.port1_data &= 0x0B
        else:
            self.dlg.btn_p12["relief"] = "raised"
            self.port1_data |= 0x04;
        self.lib.usbif4cwWriteData(0, 1, self.port1_data)

    def on_btn_p13(self):
        if self.dlg.btn_p13["relief"] == "raised":
            self.dlg.btn_p13["relief"] = "sunken"
            self.port1_data &= 0x07
        else:
            self.dlg.btn_p13["relief"] = "raised"
            self.port1_data |= 0x08;
        self.lib.usbif4cwWriteData(0, 1, self.port1_data)

    def on_destroy(self):
        # cleanup USBIF4CW.dll
        self.lib.usbif4cwClose(0)
        self.dlg.destroy()


def main():
    app = Application()
    app.dlg.mainloop()


main()
