"""
Defines the appearance of the dialog.
"""

import tkinter as tk
from PIL import Image, ImageTk

VERSION_TEXT = "Usbif4cwPortIo Version 1.0 (Oct. 13, 2018)\nCopyright (C) 2018 by JG5CBR/1"
ICON_PATH = './Usbif4cwPortIo.ico'

"""Usbif4cwPortIoDlg dialog"""
class Usbif4cwPortIoDlg(tk.Tk):
    def __init__(self):
        super().__init__()
        # Create main dialog
        self.resizable(0,0) # Do not resize the window
        self.title("USBIF4CW Port IO")
        self.geometry('340x242')
        self.iconbitmap(ICON_PATH)
        self.frame = tk.Frame(self)
        self.btn_p00 = tk.Button(self.frame,text="P00", width=6)
        self.btn_p01 = tk.Button(self.frame,text="P01", width=6)
        self.btn_p02 = tk.Button(self.frame,text="P02", width=6)
        self.btn_p03 = tk.Button(self.frame,text="P03", width=6)
        self.btn_p04 = tk.Button(self.frame,text="P04", width=6)
        self.btn_p05 = tk.Button(self.frame,text="P05", width=6)
        self.btn_p06 = tk.Button(self.frame,text="P06", width=6)
        self.btn_p07 = tk.Button(self.frame,text="P07", width=6)
        self.btn_p10 = tk.Button(self.frame,text="P10", width=6)
        self.btn_p11 = tk.Button(self.frame,text="P11", width=6)
        self.btn_p12 = tk.Button(self.frame,text="P12", width=6)
        self.btn_p13 = tk.Button(self.frame,text="P13", width=6)
        self.label_p00 = tk.Label(self.frame,text="CW output")
        self.label_p01 = tk.Label(self.frame,text="PTT output")
        self.label_p02 = tk.Label(self.frame,text="FSK output(Gen.3)")
        self.label_p03 = tk.Label(self.frame,text="Microphone switching")
        self.label_p04 = tk.Label(self.frame,text="Band data bit0")
        self.label_p05 = tk.Label(self.frame,text="Band data bit1")
        self.label_p06 = tk.Label(self.frame,text="Band data bit2")
        self.label_p07 = tk.Label(self.frame,text="Side tone")
        self.label_p10 = tk.Label(self.frame,text="Left badle")
        self.label_p11 = tk.Label(self.frame,text="Msg button")
        self.label_p12 = tk.Label(self.frame,text="Right badle")
        self.label_p13 = tk.Label(self.frame,text="Fnk button")
        self.btn_about = tk.Button(self.frame,text="Version", width=18, command=self.show_about_dlg)
        self.frame.pack(padx=5, pady=5, side='left', expand=True, fill=tk.BOTH)
        self.frame.columnconfigure(1, weight=1)
        self.frame.columnconfigure(3, weight=1)
        self.btn_p00.grid(row=0, column=0, padx=2, pady=1, sticky=tk.W)
        self.btn_p01.grid(row=1, column=0, padx=2, pady=1, sticky=tk.W)
        self.btn_p02.grid(row=2, column=0, padx=2, pady=1, sticky=tk.W)
        self.btn_p03.grid(row=3, column=0, padx=2, pady=1, sticky=tk.W)
        self.btn_p04.grid(row=4, column=0, padx=2, pady=1, sticky=tk.W)
        self.btn_p05.grid(row=5, column=0, padx=2, pady=1, sticky=tk.W)
        self.btn_p06.grid(row=6, column=0, padx=2, pady=1, sticky=tk.W)
        self.btn_p07.grid(row=7, column=0, padx=2, pady=1, sticky=tk.W)
        self.btn_p10.grid(row=0, column=2, padx=2, pady=1, sticky=tk.W)
        self.btn_p11.grid(row=1, column=2, padx=2, pady=1, sticky=tk.W)
        self.btn_p12.grid(row=2, column=2, padx=2, pady=1, sticky=tk.W)
        self.btn_p13.grid(row=3, column=2, padx=2, pady=1, sticky=tk.W)
        self.label_p00.grid(row=0, column=1, padx=2, pady=1, sticky=tk.W)
        self.label_p01.grid(row=1, column=1, padx=2, pady=1, sticky=tk.W)
        self.label_p02.grid(row=2, column=1, padx=2, pady=1, sticky=tk.W)
        self.label_p03.grid(row=3, column=1, padx=2, pady=1, sticky=tk.W)
        self.label_p04.grid(row=4, column=1, padx=2, pady=1, sticky=tk.W)
        self.label_p05.grid(row=5, column=1, padx=2, pady=1, sticky=tk.W)
        self.label_p06.grid(row=6, column=1, padx=2, pady=1, sticky=tk.W)
        self.label_p07.grid(row=7, column=1, padx=2, pady=1, sticky=tk.W)
        self.label_p10.grid(row=0, column=3, padx=2, pady=1, sticky=tk.W)
        self.label_p11.grid(row=1, column=3, padx=2, pady=1, sticky=tk.W)
        self.label_p12.grid(row=2, column=3, padx=2, pady=1, sticky=tk.W)
        self.label_p13.grid(row=3, column=3, padx=2, pady=1, sticky=tk.W)
        self.btn_about.grid(row=7, column=2, padx=2, pady=1, columnspan=2, sticky=tk.W)
        # P003ボタンにツールチップを作成
        self.set_tooltip(self.btn_p03, "While pressing this button, outputs the PC playback sound to \nthe digital terminal on the back of the USBIF4CW(Gen.3) and \nmutes the microphone input on the front.")

    def show_about_dlg(self):
        """Display version information dialog."""

        # Create widget
        about_dlg = tk.Toplevel(master=self)
        about_dlg.resizable(0,0) # Do not resize the window
        about_dlg.geometry("400x80")
        about_dlg.title("Usbif4cwPortIo version information")
        frame = tk.Frame(about_dlg)
        canvas = tk.Canvas(frame, width = 40, height = 40)
        label1 = tk.Label(frame, text=VERSION_TEXT, justify='left')
        ok_button = tk.Button(frame, text="OK", width=10, command=about_dlg.destroy)

        # Load an image and draw on the canvas
        # Note: You need to keep the reference of img variable in Python side.
        self.img = ImageTk.PhotoImage(Image.open(ICON_PATH).resize((40, 40)))
        canvas.create_image(0, 0, image=self.img, anchor=tk.NW)

        # Place widget
        frame.pack(padx=5, pady=5, side='left', expand=True, fill=tk.BOTH)
        canvas.grid(row=0, column=0, padx=10, pady=10, rowspan=2, sticky=tk.W)
        label1.grid(row=0, column=1, padx=2, pady=1, sticky=tk.W)
        ok_button.grid(row=0, column=2, padx=2, pady=1, sticky=tk.W)

    def set_tooltip(self, widget, text):
        """Create a tooltip and associate it with specified widget."""
        tooltip = None
        def on_enter(event):
            nonlocal tooltip
            # Calculate tooltip location based on location of associated widget
            x = y = 0
            x, y, cx, cy = self.bbox("insert")
            x += widget.winfo_rootx() + 25
            y += widget.winfo_rooty() + 20
            # Create tooltip window
            tooltip = tk.Toplevel(self)
            tooltip.wm_overrideredirect(True)
            tooltip.wm_geometry("+%d+%d" % (x, y))
            label = tk.Label(tooltip, text=text, justify='left',
                           background='#FFFFE1', relief='solid', borderwidth=1)
            label.pack(ipadx=1)
        def on_leave(event):
            nonlocal tooltip
            if tooltip:
                tooltip.destroy()
                tooltip = None
        widget.bind("<Enter>", on_enter)
        widget.bind("<Leave>", on_leave)
